//
// Random Program Generator
// Bryan Turner (bryan.turner@pobox.com)
// July, 2005
//

#include "Common.h"
#include "Expression.h"
#include "Type.h"
#include "Function.h"
#include "FunctionInvocation.h"
#include "Variable.h"

eTermType ExpressionTypeProbability( Function &curFunc )
{
	if ( curFunc.STMT_DEPTH > MAX_STMT_DEPTH ) return eVariable;
	if ( (genrand() % 1000) > 600 )		// 40% chance
		return eFunction;
	else
		return eVariable;
}

bool ExpressionFunctionProbability( Function &parent )
{
	if ( FuncListSize() > MAX_FUNCTIONS ) return false;
	if ( (genrand() % 1000) > 900 )		// 10% chance
		return true;
	else
		return false;
}

Expression::Expression( Function &curFunc )
{
	curFunc.STMT_DEPTH++;
	eType = ExpressionTypeProbability( curFunc );
	switch ( eType )
	{
	case eVariable:  var = SelectVariable(curFunc); break;
	case eFunction:  invoke = new FunctionInvocation( curFunc, ExpressionFunctionProbability( curFunc ) ); break;
	}
	curFunc.STMT_DEPTH--;
}

void Expression::Output( std::ostream &out )
{
	if ( eType == eFunction )
		invoke->Output( out );
	else
		var->Output( out );
};

