//
// Random Program Generator
// Bryan Turner (bryan.turner@pobox.com)
// July, 2005
//

struct Block;
struct Type;
struct Variable;

struct Function
{
	friend void GenerateFunctions();

	Function( Function & );
	void Output( std::ostream & );
	void OutputForwardDecl( std::ostream & );

	string name;
	vector<Variable*> param;
//	vector<Expression*> param_value;
	Type return_type;
//	bool isBackLink;

	vector<Block*> stack;
	Block *body;
	unsigned int STMT_DEPTH;
	unsigned long flags;
	
private:
	Function( );
	void OutputHeader( std::ostream & );
	void OutputFormalParamList( std::ostream & );
	void Init();
};

void GenerateFunctions();
Function *GetFirstFunction();
Function *SelectFunction( Function &curFunc, bool &isBackLink );
unsigned long FuncListSize();
void OutputForwardDeclarations( std::ostream &out );
void OutputFunctions( std::ostream &out );
