//
// Random Program Generator
// Bryan Turner (bryan.turner@pobox.com)
// July, 2005
//

struct Expression;
struct Function;
struct FunctionInvocation;
struct Statement;
struct Variable;
struct Block;

enum eStatementType
{
	eAssign,
	eIfElse,
	eFor,		// Make this a generic loop construct (while/for/do)
	eInvoke,
	eReturn,
	
// TODO: Re-enable continue/break when LLVM bug is fixed..
//	eBreak,		// Only inside of loops
//	eContinue,	// Only inside of loops

//  ..more?  try, catch, throw, goto

//	eHash,
	MAX_STATEMENT_TYPE
};


struct Statement
{
	eStatementType eType;
	Expression *expr;
	FunctionInvocation *invoke;
	Block *if_true;
	Statement *if_false;
	Variable *var;
	
	Statement( Function &, eStatementType = MAX_STATEMENT_TYPE );
	void Output( std::ostream & );
	
private:
	void Assign( Function & );
	void IfElse( Function & );
	void For( Function & );
	void Invoke( Function & );
	void Return( Function & );

	void OutputAssign( std::ostream & );
	void OutputIfElse( std::ostream & );
	void OutputFor( std::ostream & );
	void OutputInvoke( std::ostream & );
	void OutputReturn( std::ostream & );
};

