//
// Random Program Generator
// Bryan Turner (bryan.turner@pobox.com)
// July, 2005
//

struct Type;

enum eVariableScope
{
	eConstant,
	eGlobal,
	eParentLocal,
	eParentParam,
	eNewValue,
	MAX_VAR_SCOPE
};

struct Variable
{
	Variable() : isConst(false) {}
	void Output( std::ostream & ) const;
	void OutputDef( std::ostream & ) const;

	bool isConst;
	string name;
	Type *type;
};

// Factories..
Variable *SelectExistingVariable( Function &func );
Variable *SelectVariable( Function &func );
Variable *SelectLValue( Function &func );
void GenerateParameterVariable( Function &curFunc, Function &parent );
void OutputVariableList( vector<Variable*> &var, std::ostream &out );
void OutputGlobalVariables( std::ostream & );
void HashGlobalVariables( std::ostream & );
